
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 White
#property indicator_color2 Yellow
#property indicator_color3 Orange
#property indicator_color4 Fuchsia
#property indicator_color5 White
#property indicator_color6 Yellow
#property indicator_color7 Orange
#property indicator_color8 Fuchsia

extern int BandsPeriod = 30;
extern int BandsDeviations = 2;
int gi_84 = 0;
extern double Level1Pips = 100.0;
extern double Level2Pips = 120.0;
extern double Level3Pips = 150.0;
extern double Level4Pips = 200.0;
extern string OptWarn = "WARNING  It is optimized for EURUSD.";
double g_ibuf_128[];
double g_ibuf_132[];
double g_ibuf_136[];
double g_ibuf_140[];
double g_ibuf_144[];
double g_ibuf_148[];
double g_ibuf_152[];
double g_ibuf_156[];

int init() {
   SetIndexStyle(0, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(0, g_ibuf_128);
   SetIndexArrow(0, 140);
   SetIndexStyle(1, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(1, g_ibuf_132);
   SetIndexArrow(1, 141);
   SetIndexStyle(2, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(2, g_ibuf_136);
   SetIndexArrow(2, 142);
   SetIndexStyle(3, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(3, g_ibuf_140);
   SetIndexArrow(3, 143);
   SetIndexStyle(4, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(4, g_ibuf_144);
   SetIndexArrow(4, 140);
   SetIndexStyle(5, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(5, g_ibuf_148);
   SetIndexArrow(5, 141);
   SetIndexStyle(6, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(6, g_ibuf_152);
   SetIndexArrow(6, 142);
   SetIndexStyle(7, DRAW_ARROW, EMPTY, 1);
   SetIndexBuffer(7, g_ibuf_156);
   SetIndexArrow(7, 143);
   SetIndexDrawBegin(0, BandsPeriod + gi_84);
   SetIndexDrawBegin(1, BandsPeriod + gi_84);
   SetIndexDrawBegin(2, BandsPeriod + gi_84);
   SetIndexDrawBegin(3, BandsPeriod + gi_84);
   SetIndexDrawBegin(4, BandsPeriod + gi_84);
   SetIndexDrawBegin(5, BandsPeriod + gi_84);
   SetIndexDrawBegin(6, BandsPeriod + gi_84);
   SetIndexDrawBegin(7, BandsPeriod + gi_84);
   ObjectCreate("RevScalpSign", OBJ_LABEL, 0, 0, 0, 0, 0);
   ObjectCreate("RevScalpSignOpt", OBJ_LABEL, 0, 0, 0, 0, 0);
   return (0);
}

int deinit() {
   ObjectDelete("RevScalpSign");
   ObjectDelete("RevScalpSignOpt");
   return (0);
}

int start() {
   double ibands_8;
   double ibands_16;
   ObjectSet("RevScalpSign", OBJPROP_COLOR, White);
   ObjectSet("RevScalpSign", OBJPROP_CORNER, 2);
   ObjectSet("RevScalpSign", OBJPROP_XDISTANCE, 3);
   ObjectSet("RevScalpSign", OBJPROP_YDISTANCE, 3);
   ObjectSet("RevScalpSignOpt", OBJPROP_COLOR, White);
   ObjectSet("RevScalpSignOpt", OBJPROP_CORNER, 2);
   ObjectSet("RevScalpSignOpt", OBJPROP_XDISTANCE, 3);
   ObjectSet("RevScalpSignOpt", OBJPROP_YDISTANCE, 23);
   int ind_counted_0 = IndicatorCounted();
   if (Period() != PERIOD_M1) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Should be attached to 1 Minute Chart", 12, "Arial", White);
   else {
      ObjectSetText("RevScalpSign", "Reverse Scalping Signal : None", 12, "Arial", White);
      for (int shift_4 = Bars - ind_counted_0 - 1; shift_4 >= 0; shift_4--) {
         ibands_8 = iBands(NULL, 0, BandsPeriod, BandsDeviations, gi_84, PRICE_CLOSE, MODE_UPPER, shift_4);
         ibands_16 = iBands(NULL, 0, BandsPeriod, BandsDeviations, gi_84, PRICE_CLOSE, MODE_LOWER, shift_4);
         if (Close[shift_4] - ibands_8 > Level4Pips * Point) {
            g_ibuf_156[shift_4] = ibands_8 + Level4Pips * Point;
            if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Short     Strength : 4 (of 4)", 12, "Arial", White);
         } else {
            if (Close[shift_4] - ibands_8 > Level3Pips * Point) {
               g_ibuf_152[shift_4] = ibands_8 + Level3Pips * Point;
               if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Short     Strength : 3 (of 4)", 12, "Arial", White);
            } else {
               if (Close[shift_4] - ibands_8 > Level2Pips * Point) {
                  g_ibuf_148[shift_4] = ibands_8 + Level2Pips * Point;
                  if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Short     Strength : 2 (of 4)", 12, "Arial", White);
               } else {
                  if (Close[shift_4] - ibands_8 > Level1Pips * Point) {
                     g_ibuf_144[shift_4] = ibands_8 + Level1Pips * Point;
                     if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Short     Strength : 1 (of 4)", 12, "Arial", White);
                  } else {
                     if (ibands_16 - Close[shift_4] > Level4Pips * Point) {
                        g_ibuf_140[shift_4] = ibands_16 - Level4Pips * Point;
                        if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Long      Strength : 4 (of 4)", 12, "Arial", White);
                     } else {
                        if (ibands_16 - Close[shift_4] > Level3Pips * Point) {
                           g_ibuf_136[shift_4] = ibands_16 - Level3Pips * Point;
                           if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Long      Strength : 3 (of 4)", 12, "Arial", White);
                        } else {
                           if (ibands_16 - Close[shift_4] > Level2Pips * Point) {
                              g_ibuf_132[shift_4] = ibands_16 - Level2Pips * Point;
                              if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Long      Strength : 2 (of 4)", 12, "Arial", White);
                           } else {
                              if (ibands_16 - Close[shift_4] > Level1Pips * Point) {
                                 g_ibuf_128[shift_4] = ibands_16 - Level1Pips * Point;
                                 if (shift_4 == 0) ObjectSetText("RevScalpSign", "Reverse Scalping Signal : Long      Strength : 1 (of 4)", 12, "Arial", White);
                              }
                           }
                        }
                     }
                  }
               }
            }
         }
      }
   }
   if (StringFind(Symbol(), "EURUSD") == -1) ObjectSetText("RevScalpSignOpt", OptWarn, 10, "Arial", White);
   else ObjectSetText("RevScalpSignOpt", " ", 10, "Arial", White);
   return (0);
}